pub mod utils;
pub mod defs;
use anyhow::{anyhow,Result};
use std::path::Path;
use std::str;
use std::process::{Command};

use crate::clouds::defs::{
	Cloud,
};

pub async fn get_cloud_monitor_info(cloud: &mut Cloud, source: &str) -> Result<String> {
	let cloud_home_path = format!("{}/{}",&cloud.env.home,&source);	
	let monitor_path = format!("{}/{}",&cloud_home_path,&cloud.env.monitor_run);	
	if Path::new(&monitor_path).exists() {
    let output = Command::new("bash")
			.arg(format!("{}",&monitor_path))
			.arg("-o")
			.arg("json")
			.arg(format!("{}",&source))
			.output()?;
		if !&output.status.success() {
			return Err(anyhow!("Run {} for {} failed: {}",&cloud.env.monitor_run,&source,&output.status));
		} 
		return Ok(str::from_utf8(&output.stdout).unwrap_or_else(|_| "").to_owned());
	}
	Ok("".to_owned())
}